/*******************************************************************
                      C O P Y R I G H T  (c) 1998
        F O C U S     A U T O M A T I O N   S Y S T E M S   I N C.
                          All Rights Reserved.
 -------------------------------------------------------------------

 attach.c - Code to attach basic keypress callbacks.

 -------------------------------------------------------------------
 *******************************************************************
 * $Source: $
 * $Date: $
 * $Revision: $
 *******************************************************************
*/

/* Standard headers */
#include <stdio.h>
//#include <stdlib.h>


/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>


/* Local headers */
#include "abimport.h"
#include "proto.h"


static void process_button( PtWidget_t *widget )
{
    PtArg_t         args[2];
    PtLinkedList_t *plist;
    PtCallback_t    callback;

    PtSetArg( &args[0], Pt_CB_ARM, &plist, 0 );
    PtGetResources( widget, 1, &args );

    if ( !plist )
    {
        PtSetArg( &args[0], Pt_CB_ACTIVATE, &plist, 0 );
        PtGetResources( widget, 1, &args );
    }

    if ( !plist )
    {
        callback.event_f = keypress;
        callback.data    = NULL;

        PtSetArg( &args[0], Pt_CB_ARM,    &callback, 0 );
        PtSetArg( &args[1], Pt_CB_REPEAT, &callback, 0 );

        PtSetResources( widget, 2, &args );
    }

    callback.event_f = release_shift;
    callback.data    = NULL;

    PtSetArg( &args[0], Pt_CB_DISARM, &callback, 0 );
    PtSetResources( widget, 1, &args );

    return;
}


int attach_callbacks( PtWidget_t       *widget,
                      ApInfo_t         *apinfo,
                      PtCallbackInfo_t *cbinfo )
{
    PtWidget_t *child;

    apinfo = apinfo, cbinfo = cbinfo;

    child = PtWidgetChildBack( widget );

    while ( child )
    {
        if ( PtWidgetClass( child ) == PtButton )
        {
            process_button( child );
        }

        child = PtWidgetBrotherInFront( child );
    }

    return( Pt_CONTINUE );
}

